// +---------------------------------------+
// | C5MENU 32bits v1.2       MENU.PRG     |
// |                                       |
// | AUTOR: Francisco Garca  [Espaa]     |
// | ADAPTACION A 32BITS:                  |
// |        Juan Carlos Salinas Ojeda      |
// |        jcso@esm.com.mx                |
// |        jcso@hotmai.com (solo msn)     |
// |                                       |
// | AGRADECIMIENTO ESPECIAL: Gracias mil  |
// | a Paco Garca por cederme su cdigo y |
// | tenerme la confianza de poder hacer   |
// | algo productivo para la comunidad.    |
// |                                       |
// | 05 de JULIO de 2005,   Mxico DF      |
// |                                       |
// +---------------------------------------+

/*
   ***********************************************************************************************
   LIMITACIONES DE LA CLASE
   ---------------------------
   Bien, antes de usar la clase en tus aplicaciones, es importante que
   consideres las siguientes limitaciones:
    1.- (ARREGLADO!) Los mens popups no funcionan
    2.- Hacer lo siguiente no funciona del todo bien:    oItem:Disable()   oItem:Enable()
    3.- No ha sido probada al 100% con bitmaps de recursos
    4.- Usa solo bitmaps de 16x16 en la barra de menu principal
    5.- El bitmap de la primer opcin de la barra de menu principal no es pintado
    6.- La clausula LINK no funciona
    7.- Iconos en la barra del men principal no funcionan adecuadamente
    8.- No funciona la clusula ACCELERATOR
    9.- No funciona la clusula CHECKED
   10.- Los FONTS en los menus popups solo funcionan una vez
   Si encuentras algn otro bug, hzmelo saber a mi cuenta de correo.
   Si alguien corrige estos bugs por favor hgamelo saber para mantener actualizada
   la clase.
   Saludos
   ***********************************************************************************************
   CLASS LIMITATIONS
   -----------------
   Well, before to use this class in your apps, is very important you consider next limitations
    1.- ( FIXED !)Actions in menupopuos doesnt work
    2.- oItem:Disable()    oItem:Enable()   doestn work fine yet
    3.- The class has no been tested at 100% with resources
    4.- Use only 16x16 bitmaps in the main menu
    5.- The first option's bitmap in the main menu wont be painted
    6.- LINK clausule doesnt work
    7.- Icons in main menu doesnt work well
    8.- ACCELERATOR clausule doesnt work
    9.- CHECKED clausule doesnt work
   10.- FONTS in popup menus just work one time
   if you find another bug, please send it to my email
   IF someone fix this bugs please let me know, so i can keep the class actualized
   My Best regards
   *************************************************************************************************

*/

#include "fivewin.ch"
#include "c5menu.ch"
#define MF_BYCOMMAND        0
#define MF_UNCHECKED        0

#define NVIEW_DLL  "nviewl16.dll"

#define WCHECK if( oMenu:nLevel > 1, if( !oMenu:lNoChks,10,0 ), 0 )

#define COLOR_CAPTIONTEXT        9
#define COLOR_BTNFACE           15

#define CtlType        aStruct[1 ]
#define CtlID          aStruct[2 ]
#define itemID         aStruct[3 ]
#define itemAction     aStruct[4 ]
#define itemState      aStruct[5 ]
#define hwndItem       aStruct[6 ]
#define hDC            aStruct[7 ]
#define nTop           aStruct[8 ]
#define nLeft          aStruct[9 ]
#define nBottom        aStruct[10]
#define nRight         aStruct[11]
#define itemData       aStruct[12]

#ifdef __XPP__
   #define New    _New
   #define NewSys _NewSys
#endif

static hClass

static aPopups   := {}
static aMenus    := {}

static aAuxMenus := {}
static aAuxItems := {}

static nWAuxItem   := 0
static nTopFirst   := 0
static nBottomLast := 0

Memvar oWnd

//----------------------------------------------------------------------------//

CLASS TC5Menu

   CLASSDATA aMiPopups AS ARRAY INIT {}
   CLASSDATA aProperties INIT { "aItems", "cVarName" }
   CLASSDATA hChkSys
   CLASSDATA hVacio
//   *CLASSDATA l3DSel
   CLASSDATA lNoChks
   CLASSDATA nClrBox
   CLASSDATA nAuxLevel AS NUMERIC INIT 0
   CLASSDATA oFont
   CLASSDATA oLastItem
   CLASSDATA oMain

   DATA l3DSel
   DATA lButtonize

   DATA   aBmps
   DATA   aBrushes
   DATA   aItems

   DATA   cBitmap
   DATA   cBmpChk
   DATA   cBmpLogo
   DATA   cSound1
   DATA   cVarName

   DATA   hBmpChk
   DATA   hBmpPal
   DATA   hBrush
   DATA   hLogo
   DATA   hLogoColor
   DATA   hMenu
   DATA   hSelPen

   DATA   lCalend  AS LOGICAL INIT .F. // no utilizar ya que no responde bien
                                       // a suscesivas llamadas
   DATA   lPopup
   DATA   lSysMenu

   DATA   nLogoColor
   DATA   nClrPane
   DATA   nClrSelect
   DATA   nClrText
   DATA   nClrTxtSel
   DATA   nClrDisa
   DATA   nHItem
   DATA   nHelpId
   DATA   nLevel
   DATA   nMaxWBmp
   DATA   nWidth
   DATA   oWnd
   DATA   lTitFrom1
   DATA   oAccTable       // Accelerators table object
   DATA   oMenuItemPopup  // Many thanks to Hernn! It overcomes the limitation
                          // of API TrackPopupMenu() under 16 bits

   METHOD New( lPopup, oWnd, cBitmap, cBmpLogo, nClrPane,;
               nHItem, cBmpChk, oFont, nClrText, l3dSel, nWidth,;
               lNoChks, nClrSelect, nClrTxtSel, nClrDisa,;
               cSound1, nClrBox, nLogoColor )  CONSTRUCTOR

   METHOD ReDefine( cResName, lPopup ) CONSTRUCTOR

   METHOD NewSys( oWnd, cBitmap, cBmpLogo, nClrPane,;
                  nHItem, cBmpChk, oFont, nClrText, nWidth ) CONSTRUCTOR

   METHOD Add( oMenuItem )

   METHOD AddEdit()

   METHOD AddFile()

   METHOD AddHelp( cAbout, cCopyRight )

   METHOD AddMdi()

   METHOD Insert( oMenuItem, nAt )

   METHOD Initiate()

   METHOD Command( nCommand )

   METHOD LastItem() INLINE ::oLastItem

   METHOD Load( cInfo )

   METHOD GetMenuItem( nItemId ) INLINE  SearchItem( ::aItems, nItemId )

   METHOD GetPopup( hPopup )

   METHOD GetSubMenu( hPopup ) INLINE SearchSubMenu( Self, hPopup )

   METHOD HelpTopic()

   METHOD Activate( nRow, nCol, oWnd, lEnd )

   METHOD DelItems()

   METHOD Refresh() INLINE ::oWnd:SetMenu( Self )

   METHOD Reset() INLINE If( ::lSysMenu, GetSystemMenu( ::oWnd:hWnd, .t. ),;
                         DestroyMenu( ::hMenu ) ), ::hMenu := CreateMenu(),;
                         ::aItems := {}

   METHOD Destroy() INLINE ::FreeRes()  //, DestroyItems( ::aItems )

   METHOD End()

   METHOD Hilite( nPopUp ) INLINE ;
                           HiliteMenuItem( ::oWnd:hWnd, ::hMenu, nPopUp - 1,;
                                           nOr( MF_HILITE, MF_BYPOSITION ) )


   METHOD UnHilite( nPopUp ) INLINE ;
                           HiliteMenuItem( ::oWnd:hWnd, ::hMenu, nPopUp - 1,;
                                           nOr( MF_UNHILITE, MF_BYPOSITION ) )
   #ifndef __XPP__
      METHOD Disable() INLINE ASend( ::aItems, "Disable" ),;
                              If( ::oWnd != nil, ::Refresh(),)
   #else
      METHOD Disable() INLINE ASend( ::aItems, "Disable()" ),;
                              If( ::oWnd != nil, ::Refresh(),)
   #endif

   METHOD Save()

   METHOD SetColor( nClrPane ) INLINE if( ::hBrush != nil, DeleteObject( ::hBrush ),),;
                                   ::nClrPane := nClrPane    ,;
                                   ::hBrush := CreateSolidBrush( ::nClrPane )

   METHOD RegisColor( nClrPane )
   METHOD RegisBmp  ( cBmp, lNoDefault  )

   METHOD FreeRes()

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( lPopup, oWnd, cBitmap, cBmpLogo, nClrPane, nHItem,;
            cBmpChk, oFont, nClrText, l3dSel, nWidth, lNoChks,;
            nClrSelect, nClrTxtSel, nClrDisa, cSound1, nClrBox, nLogoColor ) CLASS TC5MENU

   local xHDC, hDCMem, hAux

   DEFAULT lPopup   := .f.
   DEFAULT nClrPane := IF( IsWinXP(), GetSysColor( COLOR_BTNFACE ), GetSysColor(COLOR_MENU) ) ,;
           nClrText := GetSysColor( COLOR_MENUTEXT )
   DEFAULT nHItem   := 18
   DEFAULT nClrSelect := GetSysColor( COLOR_ACTIVECAPTION )
   DEFAULT nClrTxtSel := GetSysColor( COLOR_CAPTIONTEXT )
   DEFAULT nLogoColor := nClrPane

   #ifdef __XPP__
      #undef New
   #endif

   ::aBrushes   := {}
   ::aBmps      := {}

   ::hMenu      := If( lPopup, CreatePopupMenu(), CreateMenu() )
   ::aItems     := {}
   ::lSysMenu   := .f.
   ::lPopup     := lPopup
   ::nClrPane   := nClrPane
   ::nClrText   := nClrText
   ::hBrush     := ::RegisColor( ::nClrPane )
   ::hBmpPal    := 0
   ::hLogo      := 0
   ::nLogoColor := nLogoColor
   ::hLogoColor := ::RegisColor( ::nLogoColor )
   ::nLevel     := ++::nAuxLevel
   ::cBitmap    := cBitmap
   ::cBmpLogo   := cBmpLogo
   ::cBmpChk    := cBmpChk
   ::nHItem     := nHItem
   ::nClrSelect := nClrSelect
   ::nClrTxtSel := nClrTxtSel
   ::nClrDisa   := nClrDisa
   ::cSound1    := cSound1
   ::lTitFrom1  := .f.
   ::lButtonize := .f.

   if ::nClrBox == nil
      ::nClrBox    := nClrBox
      ::hSelPen := CreatePen( PS_SOLID, 1, ::nClrBox )
   endif

   if ::oMain == nil
      ::oMain := self
   endif

   if ::oFont == nil
      ::oFont    := oFont
   endif

   ::nMaxWBmp := 0
   ::nWidth   := nWidth

   if ::lNoChks == nil
      ::lNoChks  := lNoChks
   endif

   ::l3DSel   := l3DSel

   if ::cBitmap != nil
      ::hBmpPal := ::RegisBmp ( ::cBitmap, .t. )
   endif

   if ::cBmpLogo != nil
      ::hLogo := ::RegisBmp( ::cBmpLogo, .t. )
   endif

   if ::hChkSys == nil
      ::hChkSys := LoadBitmap( , OBM_CHECK )
   endif

   if ::cBmpChk != nil
      ::hBmpChk := ::RegisBmp( cBmpChk )
   endif


   if lPopup
      AAdd( aPopups, Self )
      aadd( ::aMiPopups, self )
   endif

   if oWnd != nil
      oWnd:SetMenu( Self )
   endif

   if ::hVacio == nil

      xHDC    := GetDC(0)
      hDCMem  := CompatDC ( xHDC )
      ::hVacio    := CompatBmp( xHDC, 0, 0 )
      DeleteDC( hDCMem )
      DeleteDC( xHDC )

   endif

return Self

//----------------------------------------------------------------------------//

METHOD End() CLASS TC5MENU

   local nAt

   if ::oWnd != nil
      SetMenu( ::oWnd:hWnd, 0 )
   endif

   if ::hBrush != nil
      DeleteObject( ::hBrush )
      ::hBrush := nil
   endif

   if ::hBmpPal != 0
      PalBmpFree( ::hBmpPal )
      ::hBmpPal := 0
   endif

   if ::hLogo != 0
      PalBmpFree( ::hLogo )
      ::hLogo := 0
   endif

   ::Destroy()
   ::DelItems()

   if ::hMenu != 0
      DestroyMenu( ::hMenu )
      ::hMenu = 0
   endif

   if ( nAt := AScan( aPopups, { | o | o == Self } ) ) != 0
      ADel( aPopups, nAt )
      ASize( aPopups, Len( aPopups ) - 1 )
   endif

   if ( nAt := AScan( ::aMiPopups, { | o | o == Self } ) ) != 0
      ADel( ::aMiPopups, nAt )
      ASize( ::aMiPopups, Len( ::aMiPopups ) - 1 )
   endif

return nil

//----------------------------------------------------------------------------//

METHOD ReDefine( cResName, lPopup ) CLASS TC5MENU

   local hMenu := LoadMenu( GetResources(), cResName )
   local n

   ::hMenu    = hMenu
   ::aItems   = {}
   ::lSysMenu = .f.
   ::lPopup   = lPopup

   if lPopup
      // Windows does not provides a way of storing only Popups in resources
      // so we are going to create one on the fly copying it from the
      // one placed at resources
      ::hMenu = CreatePopupMenu()
      MenuClone( ::hMenu, hMenu )
      DestroyMenu( hMenu )
   endif

   ResBuild( Self )

return Self

//----------------------------------------------------------------------------//

METHOD NewSys( oWnd, cBitmap, cBmpLogo, nClrPane, nHItem,;
               cBmpChk, oFont, nClrText, nWidth ) CLASS TC5MENU

   local n, xHDC, hDCMem

   DEFAULT nClrPane := GetSysColor( COLOR_MENU ),;
           nClrText := GetSysColor( COLOR_MENUTEXT )
   DEFAULT nHItem   := 18, cBmpChk := ""

   if oWnd != nil
      ::oWnd  = oWnd
      ::hMenu = GetSystemMenu( oWnd:hWnd, .f. )
   endif
   ::oWnd:oMenu := self

   ::aItems   = {}
   ::lSysMenu = .t.

   ::nClrPane  := nClrPane
   ::nClrText  := nClrText
   ::hBrush    := ::RegisColor( ::nClrPane )
   ::hBmpPal   := 0
   ::hLogo     := 0
   ::hLogoColor:= 0
   ::nLevel    := ++::nAuxLevel
   ::cBitmap   := cBitmap
   ::cBmpLogo  := cBmpLogo
   ::nHItem    := nHItem
   ::oFont     := oFont
   ::lPopup    := .f.
   ::nWidth    := nWidth

   if ::cBitmap != nil
     ::hBmpPal := ::RegisBmp ( ::cBitmap )
   endif

   if ::cBmpLogo != nil
      ::hLogo := ::RegisBmp( ::cBmpLogo )
   endif

   if ::hChkSys == nil
      ::hChkSys := LoadBitmap( , OBM_CHECK )
   endif

   if ::cBmpChk != nil
      ::hBmpChk := ::RegisBmp( cBmpChk )
   endif

   if ::hVacio == nil

      xHDC    := GetDC(0)
      hDCMem  := CompatDC ( xHDC )
      ::hVacio    := CompatBmp( xHDC, 0, 0 )
      DeleteDC( hDCMem )
      DeleteDC( xHDC )

   endif

return Self

//----------------------------------------------------------------------------//
*--
METHOD Add( oMenuItem ) CLASS TC5MENU

   if !empty( oMenuItem:cBitmap )

      oMenuItem:hBitmap := ::RegisBmp( oMenuitem:cBitmap )

      if oMenuItem:cPrompt != nil .and. ( ::nLevel > 1 .or. ::lPopup )
         ::nMaxWBmp := max( ::nMaxWBmp, nBmpWidth( oMenuItem:hBitmap ) )
      endif

   else

      if !oMenuItem:lSeparator
         oMenuItem:hBitmap := ::hVacio
      endif

   endif

   if !empty( oMenuItem:cDisaBmp )

      oMenuItem:hDisable := ::RegisBmp( oMenuitem:cDisaBmp )

      if oMenuItem:cPrompt != nil .and. ( ::nLevel > 1 .or. ::lPopup )
         ::nMaxWBmp := max( ::nMaxWBmp, nBmpWidth( oMenuItem:hDisable ) )
      endif

   endif

   if ValType( oMenuItem:bAction ) == "O" .and. ;
      Upper( oMenuItem:bAction:ClassName() ) == "TC5MENU"

      if oMenuItem:cPrompt != nil

        AppendMenu( ::hMenu, nOr( MF_POPUP, MF_OWNERDRAW,;
                         If( oMenuItem:lHelp, MF_HELP, 0 ),;
                         If( oMenuItem:lChecked, MF_CHECKED, 0 ),;
                         If( ! oMenuItem:lActive, MF_GRAYED, 0 ),;
                         If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                    oMenuItem:bAction:hMenu,;
                    oMenuItem:cPrompt )
         oMenuItem:lPadre := .t.
      else

         AppendMenu( ::hMenu, nOR( MF_POPUP, MF_BITMAP,MF_OWNERDRAW ,;
                          If( oMenuItem:lChecked, MF_CHECKED, 0 ),;
                          If( ! oMenuItem:lActive, MF_GRAYED, 0 ),;
                          If( oMenuItem:lHelp, MF_HELP, 0 ),;
                          If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                     oMenuItem:bAction:hMenu, oMenuItem:hBitmap )
                     oMenuItem:cPrompt := " "
      endif

      AAdd( aPopups, oMenuItem:bAction )

   else

      if oMenuItem:cPrompt != nil .AND. !oMenuitem:lAux

         AppendMenu( ::hMenu,;
                     nOR( nOr( MF_ENABLED, MF_OWNERDRAW ),;
                          If( oMenuItem:lChecked, MF_CHECKED, 0 ),;
                          If( oMenuItem:lHelp, MF_HELP, 0 ),;
                          If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                     oMenuItem:nId, oMenuItem:cPrompt )
      else
*--
         if oMenuItem:cBitmap != nil

            oMenuItem:hBitmap := DupBmp( oMenuItem:hBitmap, 150, CLR_RED )

            AppendMenu( ::hMenu, nOr( MF_ENABLED, MF_BITMAP, MF_OWNERDRAW, ;
                        If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                        oMenuItem:nId, oMenuItem:hBitmap )
            oMenuItem:cPrompt := " "
         else

            AppendMenu( ::hMenu, MF_SEPARATOR, oMenuItem:nId, "" )

            oMenuItem:lSeparator := .t.
         endif
      endif
   endif

   if oMenuItem:oFont == nil
      oMenuItem:oFont := ::oFont
   endif

   if oMenuiTem:nClrText == nil
      oMenuitem:nClrText := ::nClrText
   endif

   AAdd( ::aItems,  oMenuItem )
   aadd( aAuxItems, oMenuItem )

   atail( ::aItems ):nItem  := len( ::aItems )
   atail( ::aItems ):nLevel := ::nLevel

   oMenuItem:oMenu = Self

return nil

//----------------------------------------------------------------------------//

METHOD DelItems() CLASS TC5MENU

   while Len( ::aItems ) > 0
      ATail( ::aItems ):Destroy()
   end

return nil

//----------------------------------------------------------------------------//

METHOD GetPopup( hPopup ) CLASS TC5MENU

   local nAt := AScan( aPopups, { | oPopup | oPopup:hMenu == hPopup } )

return If( nAt != 0, aPopups[ nAt ], nil )

//----------------------------------------------------------------------------//

static function SearchSubMenu( oMenu, hMenu )

   local n, oSubMenu

   for n = 1 to Len( oMenu:aItems )
      if ValType( oSubMenu := oMenu:aItems[ n ]:bAction ) == "O"
         if oSubMenu:hMenu == hMenu
            return oSubMenu
         endif
         if ( oSubMenu := SearchSubMenu( oSubMenu, hMenu ) ) != nil
            return oSubMenu
         endif
      endif
   next

return nil

//----------------------------------------------------------------------------//

METHOD Insert( oMenuItem, nAt ) CLASS TC5MENU

   local oPrevItem := If( nAt <= Len( ::aItems ), ::aItems[ nAt ], nil )

   if oPrevItem == nil
      ::Add( oMenuItem )
      return nil
   endif

   AAdd( ::aItems, nil )
   AIns( ::aItems, nAt )

   ::aItems[ nAt ] = oMenuItem

   oMenuItem:oMenu = Self

   if ValType( oMenuItem:bAction ) == "O" .and. Upper( oMenuItem:bAction:ClassName() ) == "TC5MENU"
      if oMenuItem:hBitmap == 0
         InsertMenu( ::hMenu, oPrevItem:nId, nOr( MF_POPUP,;
                     If( oMenuItem:lHelp, MF_HELP, 0 ),;
                     If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                     oMenuItem:bAction:hMenu,;
                     oMenuItem:cPrompt )
      else
         InsertMenu( ::hMenu, oPrevItem:nId, nOR( MF_POPUP, MF_BITMAP,;
                     If( oMenuItem:lHelp, MF_HELP, 0 ),;
                     If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                     oMenuItem:bAction:hMenu, oMenuItem:hBitmap )
      endif
   else
      if oMenuItem:cPrompt != nil
         InsertMenu( ::hMenu, oPrevItem:nId, ;
                     nOR( If( oMenuItem:lActive, MF_ENABLED,;
                     nOR( MF_DISABLED, MF_GRAYED ) ),;
                     If( oMenuItem:lChecked, MF_CHECKED, 0 ),;
                     If( oMenuItem:lHelp, MF_HELP, 0 ),;
                     If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                     oMenuItem:nId, oMenuItem:cPrompt )
      else
         if oMenuItem:hBitmap != 0
            InsertMenu( ::hMenu, oPrevItem:nId, nOr( MF_BITMAP,;
                        If( oMenuItem:lBreak, MF_BREAK, 0 ) ),;
                        oMenuItem:nId, oMenuItem:hBitmap )
         else
            InsertMenu( ::hMenu, oPrevItem:nId, MF_SEPARATOR,;
                        oMenuItem:nId, "" )
         endif
      endif
   endif

return nil

//----------------------------------------------------------------------------//

METHOD Initiate() CLASS TC5MENU

   local n, lWhen
   local oItem

   for n = 1 to Len( ::aItems )
      oItem = ::aItems[ n ]
      if ! Empty( oItem:bWhen )
         lWhen = Eval( oItem:bWhen, oItem )
         if ValType( lWhen ) == "L"
            if lWhen
               oItem:Enable()
            else
               oItem:Disable()
            endif
         endif
      endif
   next

return nil

//----------------------------------------------------------------------------//

METHOD Command( nCommand ) CLASS TC5MENU

  local oMenuItem := ::GetMenuItem( nCommand )

   if oMenuItem != nil
      if ValType( oMenuItem:bAction ) == "B"
         if oMenuItem:bWhen != nil .and. ! Eval( oMenuItem:bWhen )
            return nil
         endif
         ::oLastItem := oMenuItem                // [VAGNER] 13-JUN-05
         if ::lPopup                             // [VAGNER] 13-JUN-05
            ::oMenuItemPopup = oMenuItem         // [VAGNER] 13-JUN-05
         else                                    // [VAGNER] 13-JUN-05
            Eval( oMenuItem:bAction, oMenuItem ) // [VAGNER] 13-JUN-05
         endif
      endif
   endif

return nil

//----------------------------------------------------------------------------//

METHOD Activate( nRow, nCol, oWnd, lEnd ) CLASS TC5MENU

   local aPoint := { nRow, nCol }

   DEFAULT lEnd := .t.

   if oWnd != nil
      aPoint = ClientToScreen( oWnd:hWnd, aPoint )

      if lEnd
         if oWnd:oPopup != nil
            oWnd:oPopup:End()
         endif
      endif
      oWnd:oPopup = Self

      TrackPopup( ::hMenu, 2, aPoint[ 1 ], aPoint[ 2 ], 0, oWnd:hWnd )
      SysRefresh()

      if ::oMenuItemPopup != nil                              // [VAGNER] 13-JUN-05
         Eval( ::oMenuItemPopup:bAction, ::oMenuItemPopup )   // [VAGNER] 13-JUN-05
         ::oMenuItemPopup = nil                               // [VAGNER] 13-JUN-05
      endif

      if lEnd
         ::End()
         oWnd:oPopup = nil
      endif
   endif

return nil

//----------------------------------------------------------------------------//

static function SearchItem( aItems, nId )

   local n      := 1
   local lFound := .f.
   local oReturn
   local bAction

   while n <= Len( aItems ) .and. ! lFound
      if aItems[ n ]:nId == nId
         return aItems[ n ]
      else
         bAction = aItems[ n ]:bAction
         if ValType( bAction ) == "O" .and. Upper( bAction:ClassName() ) == "TC5MENU"
            if aItems[ n ]:bAction:hMenu == nId
               return aItems[ n ]
            else
               oReturn = SearchItem( aItems[ n ]:bAction:aItems, nId )
               if oReturn != nil
                  exit
               endif
            endif
         endif
      endif
      n++
   end

return oReturn

//----------------------------------------------------------------------------//

static function DestroyItem( aItems )

   local n := 1
   local oItem

   while n <= Len( aItems )
      oItem = aItems[ n ]
      if oItem:bAction != nil
         if ValType( oItem:bAction ) == "O" .and. ;
            Upper( oItem:bAction:ClassName() ) == "TC5MENU"
            DestroyItem( oItem:bAction:aItems )
         endif
      endif
      oItem:End()
      oItem:Destroy()   //Sid, I think this has been already done
      n++
   end

return nil

//----------------------------------------------------------------------------//

static function ResBuild( oMenu )

   local n
   local hMenu := oMenu:hMenu
   local hSubMenu
   local oSubMenu, oMenuItem

   for n = 1 to GetMItemCount( hMenu )
         #ifndef __XPP__
            oMenuItem          = TMenuItemC5()
         #else
            oMenuItem          = TMenuItemC5():New()
         #endif
         oMenuItem:nId      = GetMItemID( hMenu, n - 1 )
         oMenuItem:cPrompt  = GetMenuString( hMenu, n - 1, MF_BYPOSITION )
         oMenuItem:cMsg     = ""
         oMenuItem:lChecked = lAnd( GetMenuState( hMenu, n - 1, MF_BYPOSITION ), MF_CHECKED )
         oMenuItem:lActive  = ! lAnd( GetMenuState( hMenu, n - 1,;
                              MF_BYPOSITION ), nOr( MF_DISABLED, MF_GRAYED ) )
         oMenuItem:oMenu    = oMenu
         oMenuItem:hBitmap  = 0
         oMenuItem:lHelp    = .f.
         oMenuItem:lBreak   = lAnd( GetMenuState( hMenu, n - 1, MF_BYPOSITION ), MF_BREAK )
         AAdd( oMenu:aItems, oMenuItem )
         if ( hSubMenu := GetSubMenu( hMenu, n - 1 ) ) != 0
            #ifndef __XPP__
               oSubMenu          = TC5MENU()
            #else
               oSubMenu          = TC5MENU():New()
            #endif
            oSubMenu:hMenu    = hSubMenu
            oSubMenu:lSysMenu = .f.
            oSubMenu:aItems   = {}
            oMenuItem:bAction = oSubMenu
            ResBuild( oSubMenu )
         endif
   next

return nil

//----------------------------------------------------------------------------//

static function MenuClone( hTarget, hSource )

   local n
   local hSubTarget, hSubSource

   for n = 1 to GetMItemCount( hSource )
      hSubSource = GetSubMenu( hSource, n - 1 )
      if hSubSource != 0
         hSubTarget = CreatePopupMenu()
         MenuClone( hSubTarget, hSubSource )
      endif
      if lAnd( GetMenuState( hSource, n - 1, MF_BYPOSITION ), MF_SEPARATOR )
         AppendMenu( hTarget, MF_SEPARATOR, GetMItemId( hSource, n - 1 ), "" )
      else
         AppendMenu( hTarget,;
                     nLoByte( GetMenuState( hSource, n - 1, MF_BYPOSITION ) ),;
                     If( hSubSource != 0, hSubTarget,;
                         GetMItemId( hSource, n - 1 ) ),;
                     GetMenuString( hSource, n - 1, MF_BYPOSITION ) )
      endif
   next

return nil

//----------------------------------------------------------------------------//

METHOD AddMdi() CLASS TC5MENU

   #ifdef __XPP__
      #translate oWnd:ArrangeIcons => oWnd:TMdiFrame:ArrangeIcons
      #translate oWnd:Cascade      => oWnd:TMdiFrame:Cascade
      #translate oWnd:CloseAll     => oWnd:TMdiFrame:CloseAll
      #translate oWnd:IconizeAll   => oWnd:TMdiFrame:IconizeAll
      #translate oWnd:NextWindow   => oWnd:TMdiFrame:NextWindow
      #translate oWnd:Tile         => oWnd:TMdiFrame:Tile
   #endif

   C5MENUITEM "&Window"
   C5MENU
      C5MENUITEM "&Tile Vertical"   ACTION ::oWnd:Tile() ;
         MESSAGE "Vertical arranges the windows as nonoverlapping tiles" ;
         WHEN Len( ::oWnd:oWndClient:aWnd ) > 0

      C5MENUITEM "&Tile Horizontal" ACTION ::oWnd:Tile( .t. ) ;
         MESSAGE "Horizontal arranges the windows as nonoverlapping tiles" ;
         WHEN Len( ::oWnd:oWndClient:aWnd ) > 0

      C5MENUITEM "&Cascade"         ACTION ::oWnd:Cascade() ;
         MESSAGE "Arranges the windows so they overlap" ;
         WHEN Len( ::oWnd:oWndClient:aWnd ) > 0

      C5MENUITEM "&Next Window" + Chr( 9 ) + "Ctrl+F6" ;
         ACTION ::oWnd:NextWindow() MESSAGE "Selects the next window" ;
         WHEN Len( ::oWnd:oWndClient:aWnd ) > 1

      C5SEPARATOR

      C5MENUITEM "&Arrange Icons"   ACTION ::oWnd:ArrangeIcons() ;
         MESSAGE "Arrange icons at the bottom of the window" ;
         WHEN Len( ::oWnd:oWndClient:aWnd ) > 0

      C5MENUITEM "&Iconize All"     ACTION ::oWnd:IconizeAll() ;
         MESSAGE "Iconize all open windows" ;
         WHEN Len( ::oWnd:oWndClient:aWnd ) > 0

      C5MENUITEM "C&lose All"       ACTION ::oWnd:CloseAll() ;
         MESSAGE "Close all open windows" ;
         WHEN Len( ::oWnd:oWndClient:aWnd ) > 0
   C5ENDMENU

return nil

//----------------------------------------------------------------------------//

METHOD AddHelp( cAbout, cCopyRight ) CLASS TC5MENU

   C5MENUITEM "&Help"
   C5MENU
      C5MENUITEM "&Contents"    ACTION HelpIndex() ;
         MESSAGE "Show the help contents"

      C5MENUITEM "&Search for Help on..."  + Chr( 9 ) + "F1" ;
         ACTION HelpSearch() MESSAGE "Search the help for a specific item"

      C5MENUITEM "Using &help"  ACTION HelpIndex() ;
         MESSAGE "Show the help index"

      C5SEPARATOR

      C5MENUITEM "&About..."    ACTION MsgAbout( cAbout, cCopyRight ) ;
         MESSAGE "Displays program information and copyright"
   C5ENDMENU

return nil

//----------------------------------------------------------------------------//

METHOD AddEdit() CLASS TC5MENU

   local oClp

   C5MENUITEM "&Edit"
   C5MENU
      C5MENUITEM "&Undo" + Chr( 9 ) + "Ctrl+Z" ;
         MESSAGE "Undoes the last action" ;
         ACTION  ::oWnd:UnDo()

      C5MENUITEM "&Redo" + Chr( 9 ) + "Ctrl+A" ;
         MESSAGE "Redoes the previously undone action" ;
         ACTION  ::oWnd:ReDo()

      C5SEPARATOR

      C5MENUITEM "Cu&t" + Chr( 9 ) + "Ctrl+X" ;
         MESSAGE "Removes the selection and puts it on the Clipboard" ;
         ACTION ::oWnd:Cut()

      C5MENUITEM "&Copy" + Chr( 9 ) + "Ctrl+C" ;
         MESSAGE "Copies the selection and puts it on the Clipboard" ;
         ACTION ::oWnd:Copy()

      C5MENUITEM "&Paste" + Chr( 9 ) + "Ctrl+V" ;
         MESSAGE "Insert Clipboard contents at the insertion point" ;
         ACTION ::oWnd:Paste() ;
         WHEN   ( oClp := TClipboard():New(), ! oClp:IsEmpty() )

      C5MENUITEM "&Delete" + Chr( 9 ) + "Del" ;
         MESSAGE "Erases the selection" ;
         ACTION  ::oWnd:Delete() ;
         ACCELERATOR 0, VK_DELETE

      C5MENUITEM "&Select All" ;
         MESSAGE "Selects the entire document" ;
         ACTION  ::oWnd:SelectAll()

      C5SEPARATOR

      C5MENUITEM "&Find..." + Chr( 9 ) + "Ctrl+F" ;
         MESSAGE "Finds the specified text" ;
         ACTION ::oWnd:Find() ;
         ACCELERATOR ACC_CONTROL, Asc( "F" )

      C5MENUITEM "Find &Next" + Chr( 9 ) + "F3" ;
         MESSAGE "Repeats the last find" ;
         ACTION  ::oWnd:FindNext()

      C5MENUITEM "R&eplace..." + Chr( 9 ) + "Ctrl+H" ;
         MESSAGE "Replace specific text with different text" ;
         ACTION  ::oWnd:Replace()

      C5SEPARATOR

      C5MENUITEM "Pr&operties" + Chr( 9 ) + "Alt+Enter" ;
         MESSAGE "Edits properties of the current selection" ;
         ACTION ::oWnd:Properties()

   C5ENDMENU

return nil

//----------------------------------------------------------------------------//

METHOD AddFile() CLASS TC5MENU

   C5MENUITEM "&File"
   C5MENU
      C5MENUITEM "&New..." + Chr( 9 ) + "Ctrl+N" ;
         MESSAGE "Creates a new file" ;
         ACCELERATOR ACC_CONTROL, Asc( "N" )

      C5MENUITEM "&Open..." + Chr( 9 ) + "Ctrl+O" ;
         MESSAGE "Open an existing file" ;
         ACCELERATOR ACC_CONTROL, Asc( "O" ) ;
         ACTION ::oWnd:Open()

      C5MENUITEM "&Save" + Chr( 9 ) + "Ctrl+S" ;
         MESSAGE "Saves the active file" ;
         ACCELERATOR ACC_CONTROL, Asc( "S" )

      C5MENUITEM "Save &as..." + Chr( 9 ) + "Alt+A" ;
         MESSAGE "Saves the active file under a new name" ;
         ACCELERATOR ACC_ALT, Asc( "A" )

      C5MENUITEM "Save al&l" ;
         MESSAGE "Saves all open files"

      C5SEPARATOR

      C5MENUITEM "&Print..." + Chr( 9 ) + "Ctrl+P" ;
         MESSAGE "Prints the active file" ;
         ACCELERATOR ACC_CONTROL, Asc( "P" ) ;
         ACTION ::oWnd:Print()

      C5MENUITEM "P&rinter Setup..." + Chr( 9 ) + "Alt+P" ;
         MESSAGE "Select and setup the printer" ;
         ACCELERATOR ACC_ALT, Asc( "P" ) ;
         ACTION PrinterSetup()

      C5SEPARATOR

      C5MENUITEM "&Exit..." + Chr( 9 ) + "Alt+F4" ;
         MESSAGE "Quits this application" ;
         ACTION ::oWnd:End()

   C5ENDMENU

return nil

//----------------------------------------------------------------------------//

METHOD HelpTopic() CLASS TC5MENU

   if Empty( ::nHelpId )
      if ::oWnd != nil
         ::oWnd:HelpTopic()
      else
         HelpIndex()
      endif
   else
      HelpTopic( ::nHelpId )
   endif

return nil

//----------------------------------------------------------------------------//

METHOD Save() CLASS TC5MENU

   local n
   local cType, cInfo := ""
   local oWnd  := &( ::ClassName() + "()" )
   local uData, nProps := 0

   oWnd:New()

   for n = 1 to Len( ::aProperties )
       if ! ( uData := OSend( Self, ::aProperties[ n ] ) ) == ;
          OSend( oWnd, ::aProperties[ n ] )
          cInfo += ( I2Bin( Len( ::aProperties[ n ] ) ) + ;
                     ::aProperties[ n ] )
          nProps++
          cType = ValType( uData )
          do case
             case cType == "A"
                  cInfo += ASave( uData )

             case cType == "O"
                  cInfo += uData:Save()

             otherwise
                  cInfo += ( cType + I2Bin( Len( uData := cValToChar( uData ) ) ) + ;
                             uData )
          endcase
       endif
   next

   oWnd:End()

return "O" + I2Bin( 2 + Len( ::ClassName() ) + 2 + Len( cInfo ) ) + ;
       I2Bin( Len( ::ClassName() ) ) + ;
       ::ClassName() + I2Bin( nProps ) + cInfo



//----------------------------------------------------------------------------//

static function ASave( aArray )

   local n, cType, uData
   local cInfo := ""

   for n = 1 to Len( aArray )
      cType = ValType( aArray[ n ] )
      do case
         case cType == "A"
              cInfo += ASave( aArray[ n ] )

         case cType == "O"
              cInfo += aArray[ n ]:Save()

         otherwise
              cInfo += ( cType + I2Bin( Len( uData := cValToChar( uData ) ) ) + ;
                         uData )
      endcase
   next

return "A" + I2Bin( 2 + Len( cInfo ) ) + I2Bin( Len( aArray ) ) + cInfo

//----------------------------------------------------------------------------//

static function ARead( cInfo )

   local nPos := 1, nLen, n
   local aArray, cType, cBuffer

   nLen   = Bin2I( SubStr( cInfo, nPos, 2 ) )
   nPos  += 2
   aArray = Array( nLen )

   for n = 1 to Len( aArray )
      cType = SubStr( cInfo, nPos++, 1 )
      nLen  = Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cBuffer = SubStr( cInfo, nPos, nLen )
      nPos += nLen
      do case
         case cType == "A"
              aArray[ n ] = ARead( cBuffer )

         case cType == "O"
              aArray[ n ] = ORead( cBuffer )

         case cType == "C"
              aArray[ n ] = cBuffer

         case cType == "D"
              aArray[ n ] = CToD( cBuffer )

         case cType == "L"
              aArray[ n ] = ( cBuffer == "T" )

         case cType == "N"
              aArray[ n ] = Val( cBuffer )
      endcase
   next

return aArray

//----------------------------------------------------------------------------//

METHOD Load( cInfo ) CLASS TC5MENU

   local nPos := 1, nProps, n, nLen
   local cData, cType, cBuffer

   nProps = Bin2I( SubStr( cInfo, nPos, 2 ) )
   nPos += 2

   for n = 1 to nProps
      nLen  = Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cData = SubStr( cInfo, nPos, nLen )
      nPos += nLen
      cType = SubStr( cInfo, nPos++, 1 )
      nLen  = Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cBuffer = SubStr( cInfo, nPos, nLen )
      nPos += nLen
      do case
         case cType == "A"
              OSend( Self, "_" + cData, ARead( cBuffer ) )

         case cType == "O"
              OSend( Self, "_" + cData, ORead( cBuffer ) )

         case cType == "C"
              OSend( Self, "_" + cData, cBuffer )

         case cType == "L"
              OSend( Self, "_" + cData, cBuffer == "T" )

         case cType == "N"
              OSend( Self, "_" + cData, Val( cBuffer ) )
      endcase
   next

return nil

//----------------------------------------------------------------------------//
*********************************************
   METHOD RegisColor( nClrPane ) CLASS TC5Menu
*********************************************
local hBrush
local nEn

if empty( ::aBrushes )
   hBrush := CreateSolidBrush( nClrPane )
   aadd( ::aBrushes, { nClrPane, hBrush } )
else
   nEn := ascan( ::aBrushes, {|x| nClrPane == x[1] } )
   if nEn != 0
      hBrush := ::aBrushes[ nEn, 2 ]
   else
      hBrush := CreateSolidBrush( nClrPane )
      aadd( ::aBrushes, { nClrPane, hBrush } )
   endif
endif

return hBrush

*********************************************
   METHOD RegisBmp( cBmp, lNoDefault ) CLASS TC5Menu
*********************************************
local nEn
local lFile := "." $ cBmp
local hBmp, hOldBmp
local xhDC, hDCMem

DEFAULT lNoDefault := .f.

cBmp := upper( cBmp )

if empty( ::aBmps )

   aadd( ::aBmps, { "null"  , hBmp } )

endif


   nEn := ascan( ::aBmps, {|x| cBmp == x[1] } )

   if nEn != 0
      hBmp := ::aBmps[ nEn, 2 ]
   else
      if lFile
         do case
            case ".BMP" $ cBmp
                 hBmp   := ReadBitmap( 0, cBmp )

            case ".GIF" $ cBmp .or.;
                 ".JPG" $ cBmp .or.;
                 ".TGA" $ cBmp .or.;
                 ".DIB" $ cBmp .or.;
                 ".RLE" $ cBmp .or.;
                 ".PCX" $ cBmp .or.;
                 ".JIF" $ cBmp

                 if ! ( IsWin95() .or. IsWinNT() )
                    hBmp := NViewLibLoad( AllTrim( cBmp ), 0 )
                 else
                    hBmp := NViewLib32( AllTrim( cBmp ), 0 )
                 endif
         endcase
      else
         hBmp   := LoadBitmap( GetResources(), cBmp )
      endif
      if ValType( hBmp ) == "A"
         if lNoDefault
            hBmp := 0
         else
            hBmp = ::aBmps[1,2]
         endif
         return hBmp
      endif
      PalBmpNew( 0, hBmp  )
      aadd( ::aBmps, { cBmp, hBmp } )
   endif

return hBmp

**************************************
   METHOD FreeRes() CLASS TC5Menu
**************************************
local n

for n := 1 to len( ::aBrushes )
    deleteobject( ::aBrushes[n,2] )
next n

for n := 1 to len( ::aBmps )
    PalBmpFree( ::aBmps[n,2] )
next n

if ::hVacio != nil
   DeleteObject( ::hVacio )
endif

asize( ::aBrushes, 0 )
asize( ::aBmps, 0 )

if ::oFont != nil
   if ::oFont:nCount > 0
      ::oFont:End()
   endif
endif

if ::hSelPen != nil
   DeleteObject( ::hSelPen )
endif

return nil


function MenuDrawItem( pDrawItemStruct, cPrompt, lTop, hBmp )

   local aStruct

   local aRect
   local hBrush
   local hDCMem
   local hOldBmp, hBmp2
   local hOldFont
   local lBar     := .f.
   local lBmp     := !empty( hBmp )
   local lFirst   := .f.
   local lFocused := .f.
   local lFondo
   local lLogo
   local lTab      := ( at( chr(9), cPrompt ) != 0 )
   local lSelected := .f.
   local nAuxLeft
   local nColor, nOldColor, nOldBkColor
   local nHBmp    := 0
   local nHeight
   local nLen
   local nOldMode
   local nTopBmp  := 0
   local nWBmp    := 0
   local nWLogo
   local nWidth
   local oDefWnd  := GetWndDefault()
   local oItem
   local oMenu
   local oMain
   Local nY

*--
   aStruct := GetDrawISr( pDrawItemStruct )
   hDCMem  := CreateCDC( hDC )
   oMenu   := aAuxMenus[ ascan( aAuxMenus, {|x| x:hMenu == hwndItem } ) ]
   lFondo  := ( oMenu:cBitmap  != nil )
   lLogo   := ( oMenu:cBmpLogo != nil )
   oMain   := oMenu:oMain

   nAuxLeft := nLeft

   nLen := Len( oMenu:aItems )

   CursorArrow()

   if oDefWnd != nil

      /*
      * para pintar el wndboxraised al final
      * en este momento se puede saber que ventana es la propietaria porque
      * estamos pintando ya
       */

      aRect := GetClientRect( oDefWnd:hWnd )

   endif

   nHeight := nBottom - nTop
   nWidth  := nRight - nLeft

   if lBmp

      // calculo las dimensiones del bitmap que hay que dibujar a la izda.

      nHBmp := nBmpHeight( hBmp )
      nWBmp := nBmpWidth ( hBmp )
      nTopBmp := nTop + ( nHeight / 2 ) - ( nHBmp / 2 )

   endif

   // calcular el objeto oItem
   oItem := oMenu:GetMenuItem( itemID )

   lBar := oMenu:nLevel == 1 .and. !oMenu:lPopup

   if lBar .and. oItem:nItem == 1

      // * estamos pintando el primer item de la barra de men horizontal
      lFirst    := .t.
      nTopFirst := nTop

   endif

   if lBar .and. oItem:nItem == len( oMenu:aItems )

      /*
      * Estamos pintando el ltimo item de la barra horizontal
      * aprovechamos para calcular la coordenada inferior de la barra
      * horizontal para poder pintar la WndBoxRaised
      */

      nBottomLast := nBottom

   endif

   if lFondo

      // * pinto el bmp de fondo si existe. Calculo las dimensiones

      hBmp2 := oMenu:hBmpPal

      if oItem:nItem == 1 .and. itemAction != ODA_SELECT

         DrawBitmap( hDC, oMenu:hBmpPal, if( oMenu:nLevel == 1 .and. !oMenu:lPopup,18,0), 0 )
         Sysrefresh()

      endif

   endif

   if lLogo

      nWLogo := nBmpWidth ( oMenu:hLogo )
      nY     := nBottom - nBmpHeight( oMenu:hLogo ) // Si es mas grande q el menu
      IF nY < 0                                    // entonces pintamos desde arriba
         nY := 1
      EndIF

      // * Pinto el logo si existe en el momento en que estoy pintando el
      // * Ultimo item de un nLevel > 1

      if oMenu:lTitFrom1
         if oItem:nItem == 1
            DrawBitmap( hDC, oMenu:hLogo, nTop + 2, -1, nWLogo, nBmpHeight( oMenu:hLogo ) )
            Sysrefresh()
         endif
      else
         if oItem:nItem == nLen
            DrawBitmap( hDC, oMenu:hLogo, nY, 0, nWLogo, nBmpHeight( oMenu:hLogo ) )
            FillRect( hDC, { 0, 0 , nY, nBmpWidth( oMenu:hLogo ) }, oMenu:hLogoColor )
            Sysrefresh()
         endif
      endif

   endif


   do case

      case itemAction == ODA_DRAWENTIRE


           if oItem:lAux
              nWidth += 100
           endif

           //* entramos por aqu cuando el menu se esta pintando
           //* la primera vez

           if lLogo

              // * si hay logo empezara a pintar en la derecha del logo
              nLeft += nWLogo

           endif

           if !lFondo

              // * no hay bitmap de fondo

              FillRect( hDC, { nTop , nAuxLeft + if( nWLogo != nil, nWLogo, 0 ),;
                               nBottom , nRight }, oMenu:hBrush )

           endif

           if lAnd( itemState, ODS_SELECTED )

              lSelected := .t.

              /*
              * se est pintando el menu porque acaba de coger el foco
              * y hay que pintar la opcin seleccionada.
              * si no se hace esta comprobacin, al desplegarse el men
              * se quedara la primera opcin, o la seleccionada sin
              * pintar hasta que cambiaramos de opcin
              */

              // *  si no queremos efecto 3d
              if !lFondo .and. !oMenu:l3dSel

                 // * esta variable nos sirve para pintar el texto en las
                 // * opciones seleccionadas

                 lFocused := .t.

                 // * color activo del sistema por defecto

                 hBrush := CreateSolidBrush( oMenu:nClrSelect )

                 FillRect( hDC, { nTop, if( lLogo, nWLogo,0), nBottom , nRight }, hBrush )

                 if oItem:nItem < nLen .and. oMenu:aItems[ oItem:nItem + 1 ]:lSeparator

                       /*
                       * si la siguiente opcion es un separador, esta no se
                       * pintar pues los separadores no generan un mensaje
                       * measurepaint as es que tendremos que pintar el fondo
                       * a mano. Las barras del separador van por cuenta del
                       * sistema
                       */

                       FillRect( hDC, { nBottom + 1 , nLeft , ;
                        nBottom + 9 , nRight }, oMenu:hBrush ) // [WhenSheng] 04-jul-05

                    endif

                 DeleteObject( hBrush )

              else
                 // * borramos el fondo de la opcion y pintamos el wndbox
                 // * porque es efecto 3d

                 do case
                    case empty( oItem:cPrompt )

                    case oMenu:lButtonize
                         Box      ( hDC, oMain:hSelPen, nTop, nLeft  + nWBmp ,;
                                          nBottom-1, nRight-2 )
                         WndBoxIn    ( hDC, nTop+1, nLeft + nWBmp+ 1 ,;
                                          nBottom-2, nRight-3 )
                    case lBar
                         if oMain:nClrBox != nil
                            Box      ( hDC, oMain:hSelPen, nTop, nLeft  + nWBmp ,;
                                          nBottom-1, nRight-2 )
                         else
                            WndBoxIn    ( hDC, nTop, nLeft + nWBmp ,;
                                          nBottom-1, nRight-2 )
                         endif
                    otherwise
                         if !empty( oItem:cPrompt )
                            if oMain:nClrBox != nil
                               Box      ( hDC, oMain:hSelPen, nTop, nLeft +;
                                  if( lBar, nWBmp , if( oItem:cBitmap == nil,0, oMenu:nMaxWBmp  + 5 + WCHECK ) ) ,;
                                           nBottom-2, nRight-2 )
                            else
                               WndBoxRaised( hDC, nTop, nLeft +;
                                  if( lBar, nWBmp , if( oItem:cBitmap == nil,0, oMenu:nMaxWBmp  + 5 + WCHECK ) ) ,;
                                           nBottom-2, nRight-2 )
                            endif
                         endif
                 endcase

              endif
           else
              if !lFondo

                 // * estamos pintando opciones no seleccionadas

                 FillRect( hDC, { nTop , nLeft + if ( nWlogo != nil, nWLogo, 0  ) } ) // nTop - 1                         nBottom + 1, nRight }, oMenu:hBrush )

                 if oItem:nItem < nLen .and. oMenu:aItems[ oItem:nItem + 1 ]:lSeparator

                    /*
                    * si la siguiente opcion es un separador, esta no se
                    * pintara pues los separadores no generan un mensaje
                    * measurepaint asi es que tendremos que pintar el fondo
                    * a mano. Las barras del separador van por cuenta del
                    * sistema
                    */

                    FillRect( hDC, { nBottom + 1 , nLeft, ;
                                    nBottom + 9 , nRight }, oMenu:hBrush ) // [WhenSheng] 04-jul-05

                 endif
              endif

           endif

           nLeft += 2 + WCHECK

           // * aumentamos 5 a left y 10 mas si es nLevel > 1 para salvar la marca
           //* de check ( posible marca )

           if ( !empty( hBmp ) .or. oItem:hIcon > 0 ) .and. !oItem:lSeparator

               /*
               * aumentamos 4 unidades a nLeft para poder salvar
               * el dibujo de las rayitas en el primer item de la barra
               * horizontal
               */

                  oItem:PaintImg( hDC, nTopBmp,  nLeft +1 - ;
                                       if( oItem:nItem == 1 .and. oMenu:nLevel == 1, 4, 0) )
           endif

           if oItem:lChecked
              DrawMasked( hDC, oMenu:hBmpChk, nTop + 2, nLeft - WCHECK  - 3  )
           endif

           /*
           * aumentamos a todos los items que pintemos el maximo valor
           * de ancho de los dibujos pintados en items OWNERDRAW para
           * pintar a continuacion el texto.
           */

           if oMenu:nLevel > 1 .or. oMenu:lPopup
              if oItem:hIcon > 0
                 nLeft += 36
              else
                nLeft += oMenu:nMaxWBmp
              endif
           else
              if oItem:hIcon > 0
                 nLeft += 36
              else
                 if hBmp != nil
                    nLeft += nBmpWidth( hBmp )
                 endif
              endif
           endif

           nTop  = nTop + 2

           if lFocused

              /*
              * solo entramos por aqui cuando NO TIENE BITMAP DE FONDO,
              * el item pintado es el SELECCIONADO y
              * no tiene efecto 3d
              */

              SetTextColor( hDC, oMenu:nClrTxtSel )

           else
               //* se toma el color de texto del ITEM y sino el del MENU
               SetTextColor( hDC, if( oItem:nClrText != nil, oItem:nClrText, oMenu:nClrText ) )

           endif

           //* color de fondo transparente
           SetBkMode( hDC, 1 )

           /*
           * seleccionamos el font si tuviese. Hay que resear que cuando se
           * aaden los items en el metodo ADD de la clase tc5menu se comprueba
           * si se ha definido font para ese item y si no se ha definido
           * se asigna la del menu. Esta font puede ser nil y es por eso que
           * se puede hacer esta pregunta
           */

           if oItem:oFont != nil
              hOldFont := SelectObject( hDC, oItem:oFont:hFont )
           endif

           // * si el item esta disabled se pinta en desabilitado

           if !oItem:lActive

              if oMenu:nClrDisa != nil
                 SetTextColor( hDC, oMenu:nClrDisa )
              else
                 SetTextColor( hDC, CLR_WHITE )
                 DrawText( hDC, cPrompt, { nTop  , nLeft + 6+1 , nBottom  , nRight - 3 - if( oItem:lPadre .and. oMenu:nLevel > 1, 20,0 )+1  }, oItem:nTextAlign + 64)
                 SetTextColor( hDC, CLR_GRAY )
              endif
           endif

           /*
           * pintamos el texto de la opcin.
           * se aade 64 a la alineacin para que expanda los tabuladores con
           * espacios y as poder pintar los aceleradores.
           * se pintarn aadiendo un chr(9) al texto a pintar
           */

           if oMenu:lCalend
              DrawText( hDC, cPrompt,;
                  { nTop,;
                    nAuxLeft,;
                    nBottom-1,;
                    nRight },;
                    33 )
           else
              DrawText( hDC, cPrompt,;
                  { nTop + if (lSelected .and. oMenu:l3dSel .or. lFondo,1,0),; // nTop - 1
                    nLeft      + 6+ if (lSelected .and. oMenu:l3dSel .or. lFondo ,1,0),;
                    nBottom - 1+ if (lSelected .and. oMenu:l3dSel .or. lFondo,1,0),;
                    nRight  - 3 - if( oItem:lPadre .and. oMenu:nLevel > 1, 20, 0 )+ if (lSelected .and. oMenu:l3dSel .or. lFondo,1,0)  },;
                    oItem:nTextAlign + 64 )
           endif

           // * se deselecciona la font utilizada.
           if oItem:oFont != nil
              SelectObject( hDC, hOldFont )
           endif

      case itemAction == ODA_SELECT


           lSelected := .t.
           if lLogo
              // * tenemos que pintar el logo
              nLeft += nWLogo
           endif

           // * en primer lugar borramos/restauramos la zona que hay que pintar
           if !lFondo
              if oMenu:nLevel == 1
                 FillRect( hDC, { nTop    ,; // + 1
                          nLeft, nBottom , nRight}, oMenu:hBrush )
              else
                 FillRect( hDC, { nTop -1,;
                          nLeft, nBottom , nRight}, oMenu:hBrush )
              endif
           else
              hOldBmp := SelectObject( hDCMem, hBmp2 )
              bitblt( hDC, nLeft, nTop-1 , nWidth, nHeight+2, hDCMem, nLeft, nTop-1, SRCCOPY )
              SelectObject( hDCMem, hOldBmp )
           endif

           if  lAnd( itemState,  ODS_SELECTED )
               if oItem:oCursor != nil
                  SetCursor( oItem:oCursor:hCursor )
               endif

               // * si es el ITEM SELECCIONADO...
               if oMain:cSound1 != nil
                  if "." $ oMain:cSound1
                     SndPlaySound( oMain:cSound1, 1 )
                  else
                     //SndPlayRes( oMain:cSound1, 1 )
                  endif
               endif

               if !lFondo

                  // * si NO TIENE BITMAP de FONDO

                  do case

                     case !oMenu:l3dSel
                          // *  no tiene efecto 3d
                          lFocused := .t.

                          hBrush := CreateSolidBrush( oMenu:nClrSelect )

                          SetTextColor( hDC, oMenu:nClrTxtSel )

                          // * pintamos con color la opcin seleccionada

                          if oMenu:nLevel == 1
                             FillRect( hDC, { nTop  ,; // nTop + 1
                                       nLeft, ; // nWBmp if( lBar, 0    , if( oItem:cBitmap  == nil, 0, oMenu:nMaxWBmp+ 5 + WCHECK ) ),  ;
                                       nBottom , nRight }, hBrush )
                          else
                             FillRect( hDC, { nTop , if( lLogo, nWLogo,0), nBottom , nRight }, hBrush ) // nTop -1
                          endif

                          DeleteObject( hBrush )

                     otherwise
                         /*
                          * pintamos con una caja. Si estamos pintando la barra
                          * pintamos la caja hundida
                         */
                          SetTextColor( hDC, if( oItem:nClrText != nil, oItem:nClrText, oMenu:nClrText ) )


                          if !empty( oItem:cPrompt )
                             if oMenu:lButtonize
                                  Box      ( hDC, oMain:hSelPen, nTop, nLeft  + nWBmp ,;
                                             nBottom-1, nRight-2 )
                                  WndBoxIn  ( hDC, nTop+1, nLeft + nWBmp+ 1 ,;
                                               nBottom-2, nRight-3 )
                             else
                                if lBar
                                   if oMain:nClrBox != nil
                                      Box    ( hDC, oMain:hSelPen, nTop, nLeft ,; //+ nWBmp ,;
                                          nBottom-1, nRight-2 )
                                   else
                                      WndBoxIn    ( hDC, nTop, nLeft + nWBmp ,;
                                          nBottom-1, nRight-2 )
                                   endif
                                else
                                   if !empty( oItem:cPrompt )
                                      if oMain:nClrBox != nil
                                         Box      ( hDC, oMain:hSelPen, nTop, nLeft +;
                                                if( lBar, nWBmp, if( oItem:cBitmap  == nil, 0, oMenu:nMaxWBmp+ 5 + WCHECK ) ),  ;
                                               nBottom-1, nRight-2 )
                                      else
                                         WndBoxRaised( hDC, nTop, nLeft +;
                                                if( lBar, nWBmp, if( oItem:cBitmap  == nil, 0, oMenu:nMaxWBmp+ 5 + WCHECK ) ),  ;
                                               nBottom-1, nRight-2 )
                                      endif
                                   endif
                                endif
                             endif
                          endif
                  endcase
               else

                  SetTextColor( hDC, if( oItem:nClrText != nil, oItem:nClrText, oMenu:nClrText ) )

                  // * el menu tiene un bitmap de fondo

                  hOldBmp := SelectObject( hDCMem, hBmp2 )

                  // * restauramos la parte de la opcin que le toca

                  bitblt( hDC, nLeft, nTop , nWidth, nHeight+2, hDCMem, nLeft, nTop-1, SRCCOPY ) // nTop -1

                  SelectObject( hDCMem, hOldBmp )

                  // * pintamos la caja correspondiente al 3d. In o Out
                  do case
                     case empty( oItem:cPrompt )
                     case oMenu:lButtonize
                            Box      ( hDC, oMain:hSelPen, nTop, nLeft  + nWBmp ,;
                                       nBottom-1, nRight-2 )
                            WndBoxIn  ( hDC, nTop+1, nLeft + nWBmp+ 1 ,;
                                         nBottom-2, nRight-3 )
                     case lBar
                       if oMain:nClrBox != nil
                          Box    ( hDC, oMain:hSelPen, nTop, nLeft +  nWBmp , ;
                            nBottom-1, nRight-2 )
                       else
                          WndBoxIn    ( hDC, nTop, nLeft +  nWBmp , ;
                            nBottom-1, nRight-2 )
                       endif
                  otherwise
                     if !empty( oItem:cPrompt )
                        if oMain:nClrBox != nil
                           Box( hDC, oMain:hSelPen, nTop, nLeft+ ;
                               if( lBar, nWBmp, if( oItem:cBitmap  == nil, 0, oMenu:nMaxWBmp+ 5 + WCHECK ) ),  ;
                                nBottom-1, nRight-2 )
                        else
                           WndBoxRaised( hDC, nTop, nLeft+ ;
                               if( lBar, nWBmp, if( oItem:cBitmap  == nil, 0, oMenu:nMaxWBmp+ 5 + WCHECK ) ),  ;
                                nBottom-1, nRight-2 )
                        endif
                     endif
                  endcase

               endif


           else

               SetTextColor( hDC, if( oItem:nClrText != nil, oItem:nClrText, oMenu:nClrText ) )
               CursorArrow()

           endif

           // * pintamos el bitmap pequeno si lo tiene
           nLeft += 2 + WCHECK

           if !empty( hBmp ) .or. oItem:hIcon > 0 .or. oItem:lChecked

              // * pintar bitmaps pequeos on o off
              // *if oItem:lActive
                 oItem:PaintImg( hDC, nTopBmp , nLeft  +1-;
                              if( oItem:nItem == 1 .and. lBar, 4, 0) )

              //* pintar marca de check si la necesita
              if oItem:lChecked

                 if lFocused

                    // * pintamos en opcion coloreada

                    nOldColor   := SetTextColor( hDC, GetSysColor( COLOR_HIGHLIGHTTEXT ) )

                    nOldBkColor := SetBkColor  ( hDC, oMenu:nClrSelect )

                    DrawBitmap( hDC, oMenu:hBmpChk, nTop + 2, nLeft - 3 - WCHECK, nBmpWidth( oMenu:hBmpChk ), nBmpHeight( oMenu:hBmpChk ), SRCCOPY )
                    Sysrefresh()

                    SetTextColor( hDC, nOldColor   )
                    SetBkColor  ( hDC, nOldBkColor )
                 else
                    // * pintamos en opcin sin colorear, con caja
                    DrawMasked( hDC, oMenu:hBmpChk, nTop + 2 , nLeft - 3 - WCHECK )
                 endif

              endif

           endif


           if oMenu:nLevel > 1 .or. oMenu:lPopUp
              if oItem:hIcon > 0
                 nLeft += 36
              else
                 nLeft += oMenu:nMaxWBmp
              endif
           else
              if oItem:hIcon > 0
                 nLeft += 36
              else
                 if hBmp != nil
                    nLeft += nBmpWidth( hBmp )
                 endif
              endif
           endif

           nTop  = nTop + 2

           SetBkMode( hDC, 1 )

           if oItem:oFont != nil
              hOldFont := SelectObject( hDC, oItem:oFont:hFont )
           endif

           // * opcion desactivada texto en gris +/-
           if !oItem:lActive
              if oMenu:nClrDisa != nil
                 SetTextColor( hDC, oMenu:nClrDisa )
              else
                 if lFondo
                    SetTextColor( hDC, CLR_WHITE )
                    DrawText( hDC, cPrompt, { nTop, nLeft + 6+1,;
                        nBottom, nRight - 3 - if( oItem:lPadre .and. oMenu:nLevel > 1, 20,0 )+1 }, oItem:nTextAlign + 64)
                 endif
                 SetTextColor( hDC, CLR_GRAY )
              endif
           endif

           // * para pintar el texto uno para abajo y uno a la derecha
           // * efecto de hundido
           if oMenu:nLevel == 1 .and. !oMenu:lPopUp .and. lAnd( itemState,  ODS_SELECTED ) ;
              .and. oMenu:l3dSel

                 nTop    := nTop    + 1
                 nLeft   := nLeft   + 1
                 nBottom := nBottom + 1
                 nRight  := nRight  + 1

           endif

           DrawText( hDC, cPrompt,;
              { nTop  + if (lSelected .and. oMenu:l3dSel .or. lFondo,1,0),; // nTop -1
              nLeft + 6 + if (lSelected .and. oMenu:l3dSel .or. lFondo,1,0),;
              nBottom-1+ if (lSelected .and. oMenu:l3dSel .or. lFondo,1,0),;
              nRight - 3 - if( oItem:lPadre .and. oMenu:nLevel > 1, 0,0 )+ if (lSelected .and. oMenu:l3dSel.or. lFondo ,1,0) },;
              oItem:nTextAlign )

           if oItem:oFont != nil
              SelectObject( hDC, hOldFont )
           endif

           nTop  := nTop - 2
           nLeft := nLeft  - 21

           DeleteDC( hDCMem )

      case itemAction == ODA_FOCUS

   endcase

   DeleteDC( hDCMem )

return .f.


//----------------------------------------------------------------------------//

function C5MenuBegin( lPopup, lSystem, oWnd,;
                      cBitmap, cBmpLogo, nClrPane, nHItem, cBmpChk, oFont,;
                      nClrText, l3dSel, nWidth, lNoChks, nClrSelect,;
                      nClrTxtSel, nClrDisa, cSound1, nClrBox, nLogoColor  )
   local oMenu
   DEFAULT lSystem := .f.

   if lSystem
      oMenu := TC5Menu():NewSys( oWnd, cBitmap, cBmpLogo, nClrPane,;
                                 nHItem, cBmpChk, oFont, nClrText, l3dSel,;
                                 nWidth, lNoChks, nClrSelect, nClrTxtSel )
      AAdd( aMenus, { oMenu , {} } )
      oWnd:oSysMenu = ATail( aMenus )[ MENUX ]
   else
      #ifndef __XPP__
         oMenu := TC5MENU():New( lPopup, , cBitmap, cBmpLogo, nClrPane,;
            nHItem, cBmpChk, oFont, nClrText, l3dSel, nWidth, lNoChks,;
            nClrSelect, nClrTxtSel, nClrDisa, cSound1, nClrBox, nLogoColor )
         AAdd( aMenus, { oMenu                , {} } )
      #else
         oMenu := TC5MENU():New():_New( lPopup, , cBitmap, cBmpLogo, nClrPane,;
            nHItem, cBmpChk, oFont, nClrText, l3dSel, nWidth, lNoChks,;
            nClrSelect, nClrTxtSel, nClrDisa, cSound1, nClrBox, nLogoColor  )
         AAdd( aMenus, { oMenu                , {} } )
      #endif
   endif

   aadd( aAuxMenus, oMenu )

return ATail( aMenus )[ MENUX ]

//----------------------------------------------------------------------------//

function C5MenuAddItem( cPrompt, cMsg, lChecked, lActive, bAction, cBmpFile,;
                      cResName, oMenu, bBlock, nVKState, nVirtKey, lHelp,;
                      nHelpId, bWhen, lBreak, nClrText, oFont, align,;
                      cDisaBmp, cDisaRes, cIcon, oCursor )

   local oItem := TMenuItemC5():New( cPrompt, cMsg, lChecked, lActive,;
                                   If( bBlock != nil, bBlock, bAction ),;
                                   cBmpFile, cResName, nVKState, nVirtKey,;
                                   lHelp, nHelpId, bWhen, lBreak,;
                             nClrText, oFont, align, cDisaBmp, cDisaRes, cIcon, oCursor )

   AAdd( ATail( aMenus )[ ITEMSX ], oItem )

return oItem

//----------------------------------------------------------------------------//

function c5MenuEnd()

   local oMenu  := ATail( aMenus )[ MENUX ]
   local aItems := ATail( aMenus )[ ITEMSX ]

   AEval( aItems, { | oItem | oMenu:Add( oItem ) } )

   ASize( aMenus, Len( aMenus ) - 1 )
   if Len( aMenus ) > 0
      ATail( ATail( aMenus )[ ITEMSX ] ):bAction = oMenu
   endif

return oMenu

//----------------------------------------------------------------------------//

function LastMenu() ; return If( Len( aMenus ) > 0, ATail( aMenus )[ MENUX ],)

//----------------------------------------------------------------------------//

function LastItemPos()

return   If( Len( aMenus ) > 0, Len( ATail( aMenus )[ ITEMSX ] ), nil )

//----------------------------------------------------------------------------//
function MenuMeasureItem( pStru, nLen )

local aStruct := GetMeausur( pStru )
local oItem
local nWidth   := 0
local nHeight
local nMaxLine := 0
local nAux
local xHDC := GetDC(0)
local hDefFont := GetStockObject( 13 )
local hFont
local n

oItem := SearchItem( aAuxItems, itemID )

if oItem:oFont == nil
   hFont := hDefFont
else
   hFont := oItem:oFont:hFont
endif

if oItem:oMenu:lCalend
   nWidth  := 9
   nHeight := 18
else
    if oItem:oMenu:nWidth == nil

       if oItem:cPrompt != nil

          if !( CRLF $ oItem:cPrompt )
             // si no es multilinea

             if oItem:oMenu:nLevel == 1 .and. !oItem:oMenu:lPopup
                // es la barra horizontal

                nWidth := GetTextWidth( xHDC,  strtran( oItem:cPrompt,"&",""), hFont ) + ;
                          if( oItem:hIcon > 0, 36, 0 ) +;
                          nBmpWidth( oItem:hBitmap )

                 DO CASE               // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                    CASE nWidth > 80   // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                       nwidth-= 20     // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                    CASE nWidth > 70   // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                       nWidth-= 18     // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                    CASE nWidth > 60   // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                       nWidth-= 15     // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                    CASE nWidth > 50   // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                       nWidth-= 10     // AMM: el decremento [ANTONIO MARTINEZ] 14-JUNIO-2005
                 ENDCASE

             else

                // menus verticales

                nWidth := GetTextWidth( xHDC,  strtran( oItem:cPrompt,"&",""), hFont )  + ;
                    if ( oItem:oMenu:hLogo != 0, nBmpWidth( oItem:oMenu:hLogo ),0) + 3 + ;
                    oItem:oMenu:nMaxWBmp + ;
                    if( oItem:hIcon > 0, 36, 0 )+;
                    if( !oItem:oMenu:lNoChks , 10, 0 )

             endif
          else

             // menuitems multilineas

             for n := 1 to mlcount( oItem:cPrompt )
                 nAux := GetTextWidth( xHDC, alltrim( strtran( memoline( oItem:cPrompt,,n), CRLF,"" )   ),;
                        hFont )
                 nMaxLine := if( nAux > nMaxLine, nAux, nMaxLine )
             next n

             nWidth := nMaxLine + if ( oItem:oMenu:hLogo != 0, nBmpWidth( oItem:oMenu:hLogo ),0) + 3 + ;
                    If( ValType( oItem:bAction ) == "B" .and. oItem:oMenu:nLevel > 1, 20, 0 ) + ;
                    if( oItem:hIcon != 0, 36, 0 )+;
                    oItem:oMenu:nMaxWBmp

          endif

       else
          if oItem:hBitmap != nil
             nWidth := nBmpWidth( oItem:hBitmap )
          else
             nWidth := if( oItem:hIcon != 0, 36, 0 )
          endif
       endif
    else
       nWidth := oItem:oMenu:nWidth
    endif

  if oItem:nHeight == nil
     nHeight := 18
     if oItem:lSeparator
        nHeight := 6
     else
        if oItem:hIcon > 0
           nHeight := 37
        else
           if oItem:oMenu:nLevel > 1 .or.;
              oItem:oMenu:lPopup     .or.;
              oItem:oMenu:lSysmenu
              nHeight := oItem:oMenu:nHItem
           endif
        endif
     endif
  else
     nHeight := oItem:nHeight
  endif
 endif

 DeleteDC( xHDC )

Return ChgMenuMea( pStru, nWidth,  nHeight  )

function calen( dDate )
return nil

function box( hXDC, hPen, Top, Left, Bottom, Right )

   Local hOldPen := SelectObject( hXDC, hPen )

   MoveTo( hXDC, left, bottom )

   LineTo( hXDC, left, top )
   LineTo( hXDC, right, top )


   MoveTo( hXDC, left, bottom )

   LineTo( hXDC, right, bottom )
   LineTo( hXDC, right, top - 1 )

   SelectObject( hXDC, hOldPen )

return nil

function dupbmp( hBmp, nWidth, nClrPane )

local hDC
local hDCMem
local hOldBmp, hBmpMem
local nHeight
local hBrush
local nAuxW

   hDC      := GetDC(0)
   hDCMem   := CompatDC( hDC )

   nHeight  := nBmpHeight( hBmp )
   nAuxW    := nBmpWidth ( hBmp )
   hBmpMem  := CompatBmp   ( hDC, nWidth, nHeight )

   hOldBmp := SelectObject( hDCMem, hBmpMem )

   DrawBitmap( hDCMem, hBmp, 0, 0, nBmpWidth( hBmp ), nHeight, SRCCOPY )
   Sysrefresh()

   hBrush  := CreateSolidBrush( GetPixel( hDCMem, 0, 0 ) )

   fillrect( hDCMem, { 0, nAuxW, nHeight, nWidth }, hBrush )

   SelectObject( hDCMem, hOldBmp )

   DeleteObject( hBrush )

   ReleaseDC( hDCMem )
   ReleaseDC( hDC )

return hBmpMem


CLASS TMenuItemC5

   DATA   cPrompt, cMsg
   DATA   lAux     AS LOGICAL INIT .F.
   DATA   cVarName AS CHARACTER INIT ""
   DATA   nId, nHelpId
   DATA   bAction, bWhen, cWebAction
   DATA   lActive  AS LOGICAL INIT .t.
   DATA   lBreak   AS LOGICAL INIT .f.
   DATA   lChecked AS LOGICAL INIT .f.
   DATA   lHelp    AS LOGICAL INIT .f.
   DATA   oMenu
   DATA   hBitmap
   DATA   hDisable

   DATA   bAuxAction
   DATA   oFont
   DATA   nTextAlign AS NUMERIC
   DATA   nClrText
   DATA   lPadre     AS LOGICAL  INIT .f.
   DATA   lSeparator AS LOGICAL  INIT .F.

   DATA   nItem, nLevel
   DATA   cBitmap, cDisaBmp
   DATA   nHeight
   DATA   cIcon, hIcon
   DATA   oCursor

   CLASSDATA nInitId INIT 20000  // To avoid conflicts with MDI automatic MenuItems

   CLASSDATA aProperties ;
      INIT { "cCaption", "cMsg", "cVarName", "lActive", "lBreak",;
             "lChecked", "nId" }

   CLASSDATA aEvents INIT { "OnActivate", "OnClick" }

   METHOD New( cPrompt, cMsg, lChecked, lActive, bAction, cBmpFile,;
               cResName, nVKState, nVirtKey, lHelp, nHelpId, bWhen,;
               lBreak, nClrText, oFont, align, cDisaBmp, cDisaRes,;
               cIcon  ) CONSTRUCTOR

   METHOD ReDefine( cPrompt, cMsg, lChecked, lActive, bAction, cBmpFile,;
                    cResName, oMenu, bBlockAction, nId, nVKState,;
                    nVirtKey, nHelpId, bWhen ) CONSTRUCTOR

   METHOD cCaption( cText ) SETGET

   METHOD SetCheck( lOnOff ) INLINE ;
      ::lChecked := lOnOff, CheckMenuItem( ::oMenu:hMenu,;
      ::nId, nOR( MF_BYCOMMAND, If( lOnOff, MF_CHECKED, MF_UNCHECKED ) ) )

   METHOD Enable() INLINE ::lActive := .t.,;
                   If( ValType( ::bAction ) == "O",,::bAction := ::bAuxAction ) ,;
                   EnableMenuItem( ::oMenu:hMenu, ::nId, MF_ENABLED ),;
                   If( ValType( ::bAction ) == "O", ::bAction:Enable(),)

   MESSAGE HelpTopic METHOD __HelpTopic()

   METHOD Disable() INLINE ::lActive := .f.,;
      If( ValType( ::bAction ) == "O",,::bAction := nil ),;
      EnableMenuItem( ::oMenu:hMenu, ::nId, nOR( MF_DISABLED, MF_GRAYED ) ),;
      If( ValType( ::bAction ) == "O", ::bAction:Disable(),)

   METHOD End() INLINE If( ::hBitmap != 0, DeleteObject( ::hBitmap ),),;
                       if( ::oCursor != nil, ::oCursor:End(),)

   METHOD SetPrompt( cPrompt )

   METHOD PropCount() INLINE Len( ::aProperties )
   METHOD EveCount()  INLINE Len( ::aEvents )

   METHOD Inspect( cDataName ) VIRTUAL

   METHOD Property( n ) INLINE ::aProperties[ n ]
   METHOD Event( n ) INLINE ::aEvents[ n ]

   METHOD Destroy()

   METHOD Save()
   METHOD Load( cInfo )

   METHOD Refresh() VIRTUAL
   METHOD PaintImg( xhDC, xnTop, xnLeft )

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( cPrompt, cMsg, lChecked, lActive, bAction, cBmpFile, cResName,;
            nVKState, nVirtKey, lHelp, nHelpId, bWhen, lBreak,;
            nClrText, oFont, align, cDisaBmp, cDisaRes, cIcon, oCursor  ) CLASS TMenuItemc5

   Local nEn
   Local lFile

   DEFAULT lChecked := .f., lActive := .t., cBmpFile := "",;
           lHelp := .f., lBreak := .f., ;
           align := "LEFT"


   #ifdef __XPP__
      #undef New
   #endif

   ::bAction    = if( lActive, bAction, nil )
   ::bAuxAction = bAction

   ::cPrompt    = cPrompt
   ::cMsg       = cMsg
   ::lChecked   = lChecked
   ::lActive    = lActive
   ::lHelp      = lHelp
   ::lBreak     = lBreak
   ::hBitmap    = 0
   ::nHelpId    = nHelpId
   ::bWhen      = bWhen

   ::nClrText   = nClrText
   ::oFont      = oFont
   ::oCursor    = oCursor

   nEn := ascan( {"LEFT","CENTER","RIGHT"}, align )

   if nEn == 0
      nEn := 1
   endif

   ::nTextAlign = { 0, 1, 2 }[ nEn ] + if( ::cPrompt != nil .and. CRLF $ ::cPrompt, 0, 36 )

   #ifdef __XPP__
      ::lActive  = .t.
      ::lBreak   = .f.
      ::lChecked = .f.
      ::lHelp    = .f.
      if ::nInitID == nil
         ::nInitID  = 20000
      endif
   #endif

   while IsMenu( ::nInitId )   // A popup could already own the ID !!!
      ::nInitId++
   end
   ::nId = ::nInitId++

   if !empty( cBmpFile )
      ::cBitmap := cBmpFile
      ::hBitmap := ReadBitmap( 0, ::cBitmap )
   endif

   if cResName != nil
      ::cBitmap := cResName
      ::hBitmap := LoadBitmap( GetResources(), ::cBitmap )
   endif

   if !empty( cDisaBmp )
      ::cDisaBmp := cDisaBmp
   endif

   if cDisaRes != nil
      ::cDisBmp := cDisaRes
   endif

   if nVirtKey != nil

   endif

   ::cIcon    := cIcon
   ::hIcon    := 0
   if !empty( ::cIcon )
      if "." $ ::cIcon
         ::hIcon = ExtractIcon( ::cIcon )
      else
         ::hIcon = LoadIcon( GetResources(), ::cIcon )
      endif
   endif

return Self

//----------------------------------------------------------------------------//

METHOD ReDefine( cPrompt, cMsg, lChecked, lActive, bAction, cBmpFile,;
                 cResName, oMenu, bBlockAction, nId, nVKState,;
                 nVirtKey, nHelpId, bWhen ) CLASS TMenuItemc5

   local oItem

   DEFAULT oMenu := ::oMenu

   if oMenu != nil
      if ( oItem := oMenu:GetMenuItem( nId ) ) != nil
         ::bAction  = oItem:bAction
         ::cPrompt  = oItem:cPrompt
         ::cMsg     = oItem:cMsg
         ::nId      = oItem:nId
         ::lChecked = oItem:lChecked
         ::lActive  = oItem:lActive
         ::lBreak   = oItem:lBreak
         ::lHelp    = oItem:lHelp
         ::hBitmap  = oItem:hBitmap
         ::nHelpId  = oItem:nHelpId
         ::oMenu    = oItem:oMenu
         ::bWhen    = oItem:bWhen
      endif
   endif

   if lChecked != nil
      if lChecked != ::lChecked
         ::lChecked = lChecked
         if oMenu != nil .and. nId != nil
            CheckMenuItem( oMenu:hMenu, nId, nOr( MF_BYCOMMAND,;
                           If( lChecked, MF_CHECKED, MF_UNCHECKED ) ) )
         endif
      endif
   endif

   if lActive != nil
      if lActive != ::lActive
         ::lActive = lActive
         if oMenu != nil .and. nId != nil
            EnableMenuItem( oMenu:hMenu, nId, nOr( MF_BYCOMMAND,;
                            If( lActive, MF_ENABLED,;
                            nOr( MF_DISABLED, MF_GRAYED ) ) ) )
         endif
      endif
   endif

   if ! Empty( cPrompt )
      ::SetPrompt( cPrompt )
   endif

   if cMsg != nil
      ::cMsg = cMsg
   endif

   if bAction != nil
      ::bAction = bAction
   endif

   if oMenu != nil
      ::oMenu = oMenu
   endif

   if nHelpId != nil
      ::nHelpId  = nHelpId
   endif

   if bBlockAction != nil
      ::bAction = bBlockAction
   endif

   if bWhen != nil
      ::bWhen = bWhen
   endif

   if ! Empty( cBmpFile )
      ::hBitmap = ReadBitmap( 0, cBmpFile )
   endif
   if ! Empty( cResName )
      ::hBitmap = LoadBitmap( GetResources(), cResName )
   endif

   if nVirtKey != nil

   endif

   if oItem != nil
      oItem:bAction  = ::bAction
      oItem:cPrompt  = ::cPrompt
      oItem:cMsg     = ::cMsg
      oItem:nId      = ::nId
      oItem:lChecked = ::lChecked
      oItem:lActive  = ::lActive
      oItem:lHelp    = ::lHelp
      oItem:lBreak   = ::lBreak
      oItem:hBitmap  = ::hBitmap
      oItem:nHelpId  = ::nHelpId
      oItem:bWhen    = ::bWhen
   endif

return nil

//----------------------------------------------------------------------------//

METHOD SetPrompt( cPrompt ) CLASS TMenuItemc5

   local nNewId, nFlags

   ::cPrompt = cPrompt

   if ValType( ::bAction ) == "O" .and. ;
      ::bAction:ClassName() == "TMENU"
      nNewId := ::bAction:hMenu
      nFlags := MF_POPUP
   else
      nNewId := ::nId
      nFlags := nOR( If( ::lActive, MF_ENABLED,;
                nOR( MF_DISABLED, MF_GRAYED ) ),;
                If( ::lChecked, MF_CHECKED, 0 ),;
                If( ::lHelp, MF_HELP, 0 ),;
                If( ::lBreak, MF_BREAK, 0 ) )
   endif

   if ::oMenu != nil
      ModifyMenu( ::oMenu:hMenu, ::nId, nFlags, nNewId, cPrompt )

      if ::oMenu:oWnd != nil
         DrawMenuBar( ::oMenu:oWnd:hWnd )
      endif
   endif

return nil

//----------------------------------------------------------------------------//

METHOD __HelpTopic() CLASS TMenuItemc5

   if Empty( ::nHelpId )
      if ::oMenu != nil
         ::oMenu:HelpTopic()
      else
         HelpIndex()
      endif
   else
      HelpTopic( ::nHelpId )
   endif

return nil

//----------------------------------------------------------------------------//

METHOD Destroy() CLASS TMenuItemc5

   local nAt := AScan( ::oMenu:aItems,;
                       { | oItem | oItem:nId == ::nId } )

   if ValType( ::bAction ) == "O"
      ::bAction:End()
   endif

   if nAt != 0
      ADel( ::oMenu:aItems, nAt )
      ASize( ::oMenu:aItems, Len( ::oMenu:aItems ) - 1 )
   endif

   if ::oMenu:hBmpPal != 0
      PalBmpFree( ::oMenu:hBmpPal )
      ::oMenu:hBmpPal := 0
   endif

   if ::oMenu:hLogo != 0
      PalBmpFree( ::oMenu:hLogo )
      ::oMenu:hLogo := 0
   endif


   if ::oFont != nil
      ::oFont:End()
   endif

   if ::hIcon != nil
      DestroyIcon( ::hIcon )
   endif


return RemoveMenu( ::oMenu:hMenu, ::nId, MF_BYCOMMAND )

//----------------------------------------------------------------------------//

METHOD Save() CLASS TMenuItemc5

   local n
   local cType, cInfo := ""
   local oWnd  := &( ::ClassName() + "()" )
   local uData, nProps := 0

   oWnd:New()

   for n = 1 to Len( ::aProperties )
       if ! ( uData := OSend( Self, ::aProperties[ n ] ) ) == ;
          OSend( oWnd, ::aProperties[ n ] )
          cInfo += ( I2Bin( Len( ::aProperties[ n ] ) ) + ;
                     ::aProperties[ n ] )
          nProps++
          cType = ValType( uData )
          do case
             case cType == "A"
                  cInfo += xASave( uData )

             case cType == "O"
                  cInfo += uData:Save()

             otherwise
                  cInfo += ( cType + I2Bin( Len( uData := cValToChar( uData ) ) ) + ;
                             uData )
          endcase
       endif
   next

   oWnd:End()

return "O" + I2Bin( 2 + Len( ::ClassName() ) + 2 + Len( cInfo ) ) + ;
       I2Bin( Len( ::ClassName() ) ) + ;
       ::ClassName() + I2Bin( nProps ) + cInfo

//----------------------------------------------------------------------------//

static function xASave( xaArray )

   local n, cType, uData
   local cInfo := ""

   for n = 1 to Len( xaArray )
      cType = ValType( xaArray[ n ] )
      do case
         case cType == "A"
              cInfo += xASave( xaArray[ n ] )

         case cType == "O"
              cInfo += xaArray[ n ]:Save()

         otherwise
              cInfo += ( cType + I2Bin( Len( uData := cValToChar( uData ) ) ) + ;
                         uData )
      endcase
   next

return "A" + I2Bin( 2 + Len( cInfo ) ) + I2Bin( Len( xaArray ) ) + cInfo

//----------------------------------------------------------------------------//

static function xARead( cInfo )

   local nPos := 1, nLen, n
   local aArray, cType, cBuffer

   nLen   = Bin2I( SubStr( cInfo, nPos, 2 ) )
   nPos  += 2
   aArray = Array( nLen )

   for n = 1 to Len( aArray )
      cType = SubStr( cInfo, nPos++, 1 )
      nLen  = Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cBuffer = SubStr( cInfo, nPos, nLen )
      nPos += nLen
      do case
         case cType == "A"
              aArray[ n ] = xARead( cBuffer )

         case cType == "O"
              aArray[ n ] = ORead( cBuffer )

         case cType == "C"
              aArray[ n ] = cBuffer

         case cType == "D"
              aArray[ n ] = CToD( cBuffer )

         case cType == "L"
              aArray[ n ] = ( cBuffer == "T" )

         case cType == "N"
              aArray[ n ] = Val( cBuffer )
      endcase
   next

return aArray

//----------------------------------------------------------------------------//

METHOD Load( cInfo ) CLASS TMenuItemc5

   local nPos := 1, nProps, n, nLen
   local cData, cType, cBuffer

   nProps = Bin2I( SubStr( cInfo, nPos, 2 ) )
   nPos += 2

   for n = 1 to nProps
      nLen  = Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cData = SubStr( cInfo, nPos, nLen )
      nPos += nLen
      cType = SubStr( cInfo, nPos++, 1 )
      nLen  = Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cBuffer = SubStr( cInfo, nPos, nLen )
      nPos += nLen
      do case
         case cType == "A"
              OSend( Self, "_" + cData, ARead( cBuffer ) )

         case cType == "O"
              OSend( Self, "_" + cData, ORead( cBuffer ) )

         case cType == "C"
              OSend( Self, "_" + cData, cBuffer )

         case cType == "L"
              OSend( Self, "_" + cData, cBuffer == "T" )

         case cType == "N"
              OSend( Self, "_" + cData, Val( cBuffer ) )
      endcase
   next

return nil

//----------------------------------------------------------------------------//

METHOD cCaption( cText ) CLASS TMenuItemc5

   if PCount() > 0
      ::SetPrompt( cText )
   else
      return ::cPrompt
   endif

return nil

//----------------------------------------------------------------------------//


*************************************************
   METHOD PaintImg( xhDC, xnTop, xnLeft ) CLASS TMenuItemC5
*************************************************

if ::hIcon > 0
   DrawIcon( xhDC, xnTop -16, xnLeft, ::hIcon )
else
   if ::hBitmap # 0
      if ::lActive
         DrawMasked( xhDC, ::hBitmap, xnTop , xnLeft -5  )
      else
        DrawMasked( xhDC, ::hDisable, xnTop, xnLeft - 5  )
      endif
   endif
endif

return nil

DLL Function NViewLibLoad( cName AS STRING, nShow AS _INT ) ;
      AS _INT PASCAL LIB NVIEW_DLL

DLL32 Function NViewLib32( cName AS STRING, nShow AS LONG ) ;
      AS LONG PASCAL FROM "NViewLibLoad" LIB "nviewlib.dll"



#pragma BEGINDUMP

#include <Windows.h>
#include "hbApi.h"

HB_FUNC( CHGMENUMEA ) // pMeasureItemStruct, nWidth, nHeight
{
   LPMEASUREITEMSTRUCT lp = ( LPMEASUREITEMSTRUCT ) hb_parnl( 1 );

   lp->itemWidth  = hb_parni( 2 ) ;
   lp->itemHeight = hb_parni( 3 ) ;

}


HB_FUNC( MENUMEASUR ) // EITEM( pMeasureItemStruct, nLen )
{
   LPMEASUREITEMSTRUCT lp = ( LPMEASUREITEMSTRUCT ) hb_parnl( 1 );

   lp->itemWidth  = hb_parni( 2 )  ;
   lp->itemHeight = 35;
}


HB_FUNC( GETDRAWISR ) // ( pDrawitemstruct )
{
   LPDRAWITEMSTRUCT lp = ( LPDRAWITEMSTRUCT ) hb_parnl( 1 );

   hb_reta( 12 );

   hb_storni( lp->CtlType      ,    -1, 1  );
   hb_storni( lp->CtlID        ,    -1, 2  );
   hb_storni( lp->itemID       ,    -1, 3  );
   hb_storni( lp->itemAction   ,    -1, 4  );
   hb_storni( lp->itemState    ,    -1, 5  );
   hb_storni( ( LONG ) lp->hwndItem     ,    -1, 6  );
   hb_storni( ( LONG ) lp->hDC          ,    -1, 7  );
   hb_storni( lp->rcItem.top   ,    -1, 8  );
   hb_storni( lp->rcItem.left  ,    -1, 9  );
   hb_storni( lp->rcItem.bottom,    -1, 10 );
   hb_storni( lp->rcItem.right ,    -1, 11 );
   hb_stornd( lp->itemData     ,    -1, 12 );

}

HB_FUNC( GETMEAUSUR ) // ( pMeasureItemStruct )
{
   LPMEASUREITEMSTRUCT lp = ( LPMEASUREITEMSTRUCT ) hb_parnl( 1 );

   hb_reta( 6 );

   hb_storni( lp->CtlType      ,    -1, 1  );
   hb_storni( lp->CtlID        ,    -1, 2  );
   hb_storni( lp->itemID       ,    -1, 3  );
   hb_storni( lp->itemWidth    ,    -1, 4  );
   hb_storni( lp->itemHeight   ,    -1, 5  );
   hb_stornd( lp->itemData     ,    -1, 12 );

}


HB_FUNC( SETROP2 )  // (hdc, fnDrawMode)
{
   hb_retni( ( LONG ) SetROP2( ( HDC ) hb_parni( 1 ), hb_parnl( 2 ) ));
}

//----------------------------------------------------------------------------//


HB_FUNC( RECTGOMA )  // ( hWnd, nTop, nLeft, nBottom, nRight )
{
   HWND hWnd = ( HWND ) hb_parni( 1 );
   RECT rct;
   HDC  hDC     = GetDC( hWnd );
   HRGN hReg;
   int iRop;
   HPEN hPen = CreatePen( PS_SOLID, 1, RGB( 128,128,128)  );
   HPEN hOldPen;
   POINT pt;

   rct.top    = hb_parni( 2 );
   rct.left   = hb_parni( 3 );
   rct.bottom = hb_parni( 4 );
   rct.right  = hb_parni( 5 );

   iRop = SetROP2( hDC, R2_XORPEN );

   hOldPen = SelectObject( hDC, hPen );

   #ifndef __FLAT__
           MoveTo( hDC, rct.left,  rct.top );
   #else
           MoveToEx( hDC, rct.left,  rct.top , &pt );
   #endif

   LineTo( hDC, rct.right, rct.top );
   LineTo( hDC, rct.right, rct.bottom );
   LineTo( hDC, rct.left,  rct.bottom );
   LineTo( hDC, rct.left,  rct.top );

   SelectObject( hDC, hOldPen );
   DeleteObject( hPen );
   SetROP2( hDC, iRop );
   ReleaseDC( hWnd, hDC );
}


HB_FUNC( ROUNDRECT )
{
   hb_retl( RoundRect( ( HDC ) hb_parni( 1 ),            // HDC
                               hb_parni( 2 ),            // nLeft
                               hb_parni( 3 ),            // nTop
                               hb_parni( 4 ),            // nRight
                               hb_parni( 5 ),            // nBottom
                               hb_parni( 6 ),            // nWidthEllipse
                               hb_parni( 7 ) ) );        // nHeightEllipse
}

HB_FUNC( COMPATDC )  // ( hDC )
{
   hb_retnl( ( LONG ) CreateCompatibleDC( ( HDC ) hb_parnl( 1 ) ) );
}

//----------------------------------------------------------------------------//
HB_FUNC( COMPATBMP )
{
   hb_retnl( ( LONG ) CreateCompatibleBitmap( ( HDC ) hb_parnl( 1 ), hb_parni( 2 ), hb_parni( 3 ) ) );
}

HB_FUNC( BITBLT )
{
   hb_retl( BitBlt( ( HDC ) hb_parnl( 1 ),
                            hb_parni( 2 ),
                            hb_parni( 3 ),
                            hb_parni( 4 ),
                            hb_parni( 5 ),
                    ( HDC ) hb_parnl( 6 ),
                            hb_parni( 7 ),
                            hb_parni( 8 ),
                            hb_parnl( 9 ) ) );
}


HB_FUNC( STRETCHBLT )
{
   hb_retl(StretchBlt( ( HDC ) hb_parni(1),hb_parni(2),hb_parni(3),hb_parni(4),hb_parni(5),
                     ( HDC ) hb_parni(6),hb_parni(7),hb_parni(8),hb_parni(9),hb_parni(10),
                     hb_parnl(11)));

}

HB_FUNC( MAKEMEM )  // hDC, nWidth, nHeight, nColor
{

 HDC     hDC           ;
 HDC     hDCMem        ;
 HBRUSH  hBrush        ;
 HBITMAP hBmp, hOldBmp ;
 int nWidth, nHeight   ;
 int nColor            ;
 RECT rct              ;

 hDC     = ( HDC ) hb_parni( 1 ) ;
 nWidth  = hb_parni( 2 ) ;
 nHeight = hb_parni( 3 ) ;
 nColor  = hb_parni( 4 ) ;

 rct.top    =       0 ;
 rct.left   =       0 ;
 rct.bottom = nHeight ;
 rct.right  = nWidth  ;

 hDCMem  = CreateCompatibleDC( hDC );
 hBmp    = CreateCompatibleBitmap( hDC, nWidth, nHeight ) ;

 hOldBmp = SelectObject( hDCMem, hBmp ) ;

 hBrush  = CreateSolidBrush( nColor ) ;

 FillRect( hDCMem, &rct, hBrush ) ;

 SelectObject( hDCMem, hOldBmp ) ;

 DeleteObject( hBrush ) ;

 DeleteDC( hDCMem );

  hb_retnl( ( LONG ) hBmp );

}

HB_FUNC( DRAWFOCUSRECT )  //RECT

{
   RECT rct ;
   HDC  hDC = ( HDC ) hb_parni( 1 );

   rct.top    = hb_parni( 2 );
   rct.left   = hb_parni( 3 );
   rct.bottom = hb_parni( 4 );
   rct.right  = hb_parni( 5 );

   DrawFocusRect( hDC, &rct );

}

#pragma ENDDUMP
